/* Image filter library for sqcam driver by philippe Corbes (04/02/2007)
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef IMAGE_FILTER_H
#define IMAGE_FILTER_H

/************************ Image Filter  **************************/
#define FILTER_DEFAUL_GAMMA		3
#define FILTER_DEFAUL_OFFSET	0
#define FILTER_DEFAUL_GAIN		256
#define FILTER_UPDATED			0
#define FILTER_UPDATE_GAMMA		3
#define FILTER_UPDATE_RED		2
#define FILTER_UPDATE_GREEN		4
#define FILTER_UPDATE_BLUE		8

struct image_filter {
	int enabled;
	int change;
	int Gamma;
	int OffsetRed;
	int OffsetBlue;
	int OffsetGreen;
	int GainRed;
	int GainBlue;
	int GainGreen;
	unsigned char red[256];
	unsigned char green[256];
	unsigned char blue[256];
};

static void image_filter_set(struct image_filter *filter);
static void image_filter_update(struct image_filter *filter);
static void image_filter_apply(struct image_filter *filter, unsigned char *image, unsigned int size);

#endif	/* IMAGE_FILTER_H */
